; +++++++++ Customized toolbar example ++++++++++
; ++++++++++ Programmed by Luis Costa +++++++++++
; ++++++++++++++ Lisbon,Postugal ++++++++++++++++
; ++++++++++++  xandaz@hotmail.com ++++++++++++++


.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

NoButtons           equ     6
DRAW_GRIPPER        equ     0100h
WS_TOOLBAR          equ     WS_VISIBLE+WS_CHILD+TBSTYLE_CUSTOMERASE+TBSTYLE_FLAT

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      'Customized Toolbar',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW+CS_DROPSHADOW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>

; ++++ Toolbar related +++++

hToolbar        dd      ?
ToolbarClass    db      'ToolbarWindow32',0
TBButtons       TBBUTTON        <0,20h,TBSTATE_ENABLED,BTNS_SEP,DRAW_GRIPPER,1>
                TBBUTTON        <0,0,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>                        
                TBBUTTON        <0,1,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,2,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,3,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                TBBUTTON        <0,4,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
                
hMemDC      HDC     ?
hDC         HDC     ?
rect        RECT        <>
BmpHandles      dd      10 dup(?)

.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    local   BtnSize:WORD
    local   wcx:WNDCLASSEX
    
    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
    .elseif uMsg==WM_CREATE
        mov     edi,lParam
        .if     [edi.CREATESTRUCT].hWndParent==NULL

            invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_TOOLBAR,\
                    0,0,CW_USEDEFAULT,CW_USEDEFAULT,hWnd,0100h,hInstance,NULL
            mov     hToolbar,eax
            invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
            invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoButtons,addr TBButtons
            invoke  SendMessage,hToolbar,TB_SETBUTTONSIZE,NULL,200020h
            invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL
            mov     esi,0100
            lea     edi,BmpHandles
            mov     ecx,15
            cld
bmp_loop:
            push    ecx
            invoke  LoadBitmap,hInstance,esi
            stosd
            pop     ecx
            dec     ecx
            jcxz    end_bmp_loop
            inc     esi
            jmp     bmp_loop
end_bmp_loop:            
            
        .endif    
    .elseif uMsg==WM_NOTIFY
        mov     edi,lParam
        .if     [edi.NMTBCUSTOMDRAW].nmcd.hdr.code==NM_CUSTOMDRAW
           .if      [edi.NMTBCUSTOMDRAW].nmcd.dwDrawStage==CDDS_PREPAINT
                mov     eax,CDRF_NOTIFYITEMDRAW+TBCDRF_NOBACKGROUND
                ret
            .elseif [edi.NMTBCUSTOMDRAW].nmcd.dwDrawStage==CDDS_ITEMPREPAINT
                invoke  CreateCompatibleDC,[edi.NMTBCUSTOMDRAW].nmcd.hdc
                mov     hMemDC,eax
                mov     eax,[edi.NMTBCUSTOMDRAW].nmcd.dwItemSpec
                shl     eax,3
                lea     esi,BmpHandles
                add     esi,eax
                test    [edi.NMTBCUSTOMDRAW].nmcd.uItemState,CDIS_SELECTED
                jz      unselected
                add     esi,4
                invoke  SelectObject,hMemDC,dword ptr [esi]
                jmp     draw
unselected:               
                invoke  SelectObject,hMemDC,dword ptr [esi]
draw:
                lea     esi,[edi.NMTBCUSTOMDRAW].nmcd.rc
                assume  esi:PTR RECT
                invoke  StretchBlt,[edi.NMTBCUSTOMDRAW].nmcd.hdc,[edi.NMTBCUSTOMDRAW].nmcd.rc.left\
                ,[edi.NMTBCUSTOMDRAW].nmcd.rc.top,[edi.NMTBCUSTOMDRAW].nmcd.rc.right\
                ,[edi.NMTBCUSTOMDRAW].nmcd.rc.bottom,hMemDC,0,0,[esi].right,[esi].bottom,SRCCOPY
end_draw:                
                invoke  DeleteDC,hMemDC
                mov     eax,CDRF_SKIPDEFAULT
                ret                               
                                            
            .endif
        .endif                                               
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end start                                            
